package simulator.stats.implementation.out;

import simulator.stats.implementation.AccumulatedResourceStats;
import simulator.stats.implementation.GSSAccumulatorsStats;
import simulator.stats.implementation.JobStats;
import simulator.stats.implementation.MetricsStats;
import simulator.stats.implementation.ResourceAirflowStats;
import simulator.stats.implementation.ResourceAvailabilityStats;
import simulator.stats.implementation.ResourceHistoryStats;
import simulator.stats.implementation.ResourcePowerStats;
import simulator.stats.implementation.ResourceStats;
import simulator.stats.implementation.ResourceTemperatureStats;
import simulator.stats.implementation.ResourceUsageStats;
import simulator.stats.implementation.ResourceUsefulWorkStats;
import simulator.stats.implementation.TaskStats;

/**
 * 
 * @author Marcin Krystek
 *
 */
public interface StatsSerializer {

	public Object visit(TaskStats arg);
	
	public Object visit(JobStats arg);
	
	public Object visit(ResourceStats arg);
	
	public Object visit(AccumulatedResourceStats arg);
	
	public Object visit(ResourceUsageStats arg);
	
	public Object visit(ResourcePowerStats arg);

	public Object visit(ResourceAirflowStats arg);
	
	public Object visit(ResourceTemperatureStats arg);
	
	public Object visit(ResourceUsefulWorkStats arg);
	
	public Object visit(GSSAccumulatorsStats arg);
	
	public Object visit(MetricsStats arg);
	
	public Object visit(ResourceHistoryStats arg);

	public Object visit(ResourceAvailabilityStats resourceAvailabilityStats);
	
}
